<template>
  <v-card
    flat
  >
  <v-card-text>
    <v-list dense>
      <v-list-item-title class="title">
        Driving Instructions
      </v-list-item-title>
      <v-list-item-subtitle>
        {{ humanizeDistance(distance) }}, {{ humanizeDuration(duration) }}
      </v-list-item-subtitle>

      <v-list-item
        v-for="(instruction, i) in instructions"
        :key="i"
      >
        <v-list-item-icon>
          <v-icon
            v-text="getSignIcon(instruction.sign)"
          ></v-icon>
        </v-list-item-icon>
        <v-list-item-content>
          {{ instruction.text }}
        </v-list-item-content>
        <v-list-item-action>
          {{ instruction.distance.toFixed(2) }} m
        </v-list-item-action>
      </v-list-item>
    </v-list>
  </v-card-text>
  </v-card>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';

import humanizeDuration from 'humanize-duration';

import { Instruction, Sign } from '@/services/RoutingService';

const ICONS: { [key in number]: string } = {
    [Sign.DESTINATIONREACHED]: 'map-marker',
    [Sign.SLIGHTLEFT]: 'arrow-bottom-right',
    [Sign.SLIGHTRIGHT]: 'arrow-bottom-right',
    [Sign.SHARPLEFT]: 'subdirectory-arrow-left',
    [Sign.SHARPRIGHT]: 'subdirectory-arrow-right',
    [Sign.LEFT]: 'subdirectory-arrow-left',
    [Sign.RIGHT]: 'subdirectory-arrow-right',
    [Sign.STRAIGHT]: 'arrow-down',
    [Sign.ROUNDABOUT]: 'restart',
};

@Component
export default class RouteInstructions extends Vue {
  @Prop() private readonly instructions!: Instruction[];
  @Prop() private readonly duration!: number;
  @Prop() private readonly distance!: number;

  public getSignIcon(sign: Sign): string {
    return 'mdi-' + ICONS[sign];
  }

  public humanizeDistance(meters: number): string {
    const kilometers = meters / 1000;
    return kilometers.toFixed(2) + ' km';
  }

  public humanizeDuration(ms: number): string {
    return humanizeDuration(
      ms,
      {
        round: true,
        units: ['d', 'h', 'm'],
      },
    );
  }
}
</script>
